﻿#include "DataTif.h"
#include <math.h>

DataTif::DataTif(char** files, int filecount, char* newfilename,
                 bool shellused, double shelltabing,
                 double coreshell, double shellbrightness){
    useshell = shellused;
    shellI = shellbrightness;

    // get dimensions
	FILE* f = fopen(files[0],"r");
	int columns = 0; char c;
    int lines = 0;
	while(!feof(f)){
		c = fgetc(f);
        if(c =='\t' && lines == 0) columns++;
        if(c =='\n') lines++;
	}
	fclose(f);
	
    // determine max/min
    double min = 0;
    double max = min - 1;

	double dummy;
	for(int i = 0; i < filecount; i++){
		f = fopen(files[i],"r");
		while(!feof(f)){
            for(int j = 0; j < columns; j++){
				fscanf(f,"%lf\t",&dummy);
                if(min > max)
                    min = max = dummy;
                else{
                    if(dummy > max) max = dummy;
                    if(dummy < min) min = dummy;
                }
			}
		}
		fclose(f);
    }
    cs = (coreshell-min)/(max-min);
    ss = shelltabing/(max-min);


	FILE* nf = fopen(newfilename,"wb");
	unsigned int co = header(nf);

	/*Dateien einlesen, Bild erzeugen*/
	unsigned char R,G,B;
	for(int i = 0; i < filecount; i++){
		if(i < filecount -1)
            co = IFD(nf,co,(unsigned int)columns,(unsigned int)lines,1);
		else
            co = IFD(nf,co,(unsigned int)columns,(unsigned int)lines,0);
		f = fopen(files[i],"r");
        while(!feof(f)){
            for(int j = 0; j < columns; j++){
				fscanf(f,"%lf\t",&dummy);
				colorgradient(dummy,min,max,&R,&G,&B);
				fwrite(&R,1,1,nf);
				fwrite(&G,1,1,nf);
				fwrite(&B,1,1,nf);
			}
		}
		fclose(f);
    }
	fclose(nf);
}
DataTif::DataTif(unsigned char*** data, int lines, int columns, int csheet,
                 char* dest){
    FILE* nf = fopen(dest,"wb");
    unsigned int co = header(nf);

    /*Dateien einlesen, Bild erzeugen*/
    for(int i = 0; i < csheet; i++){
        if(i < csheet-1)
            co = IFD(nf,co,columns,lines,1);
        else
            co = IFD(nf,co,columns,lines,0);
        for(int h = 0; h < lines; h++)
            fwrite(data[i][h],columns*3,1,nf);
        }
    fclose(nf);
}
DataTif::DataTif(char* newfilename){
	unsigned int width = 100, height= 732, ps = 8;
	unsigned short tag = 42,typ,values; unsigned int count, value = 8+ 3*2 + 2*4 + 2*4*height;
	/*Tiff-Header*/
	FILE* f = fopen(newfilename,"wb");
	putc('I',f);putc('I',f);			//Little Endian
	fwrite(&tag,2,1,f);					//tiff-tag
	fwrite(&value,4,1,f);				//offset zu Image File Directory

	/*zusaetzliche IFD-Daten, die nicht in die IFD-Value-Bereiche gepasst haben*/
	values = 8; ps = ps + 3*2;			//Bits per sample tag
	fwrite(&values,2,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
	value = 300; ps = ps + 2*4;			//Resolution
	fwrite(&value,4,1,f);value = 1;fwrite(&value,4,1,f);
	value = width*3; ps = ps + height*4;//StripByteCount
    for(int y = 0; y < int(height); y++)	fwrite(&value,4,1,f);
    for(int y = 0; y < int(height); y++){//Strip Offset Tag
		value = ps + 4 * height + 2 + 12*12 + 4 + y * width*3;
		fwrite(&value,4,1,f);
	}

	/*erster IFD, Anzahl tags*/
	typ = 12;
	fwrite(&typ,1,2,f);
   /* Width tag*/
	tag = 256; typ = 4; count = 1; value = width;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Height tag*/
	tag = 257; typ = 4; count = 1; value = height;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Bits per sample tag [Nutzt Pointer zu offset 0]*/
	tag = 258; typ = 3; count = 3; value = 8;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Compression flag, short int */
	tag = 259; typ = 3; count = 1; values = 1;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
   /* Photometric interpolation tag, short int */
	tag = 262; typ = 3; count = 1; values = 2;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
   /* Strip offset tag, long int */
	tag = 273; typ = 4; count = height; value = ps;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Sample per pixel tag, short int */
	tag = 277; typ = 3; count = 1; values = 3;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
   /* Rows per strip tag, short int */
	tag = 278; typ = 4; count = 1; value = 1;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Strip byte count [Nutzt Pointer zu offset 22] */
	tag = 279; typ = 4; count = height; value = 22;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Resulution x [Nutzt Pointer zu offset 14]*/
	tag = 282; typ = 5; count = 1; value = 14;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
	/* Resulution y [Nutzt Pointer zu offset 18]*/
	tag = 283; typ = 5; count = 1; value = 18;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
	/* Resolution unit */
	tag = 296; typ = 3; count = 1; values = 1;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
	/*End of IFD*/
	value = 0;
	fwrite(&value,4,1,f);


	/*Bilddaten schreiben*/
	unsigned char R,G,B;
	for(int y = height -1; y >= 0; y--)
        for(int x = 0; x < int(width); x++){
			colorgradient(x,0,width-1,&R,&G,&B);
            R = (unsigned char)(R * 1. * y/(height-1));
            G = (unsigned char)(G * 1. * y/(height-1));
            B = (unsigned char)(B * 1. * y/(height-1));
			/*if(x % 3 == 0) R = 255; else R = 0;
			if(x % 3 == 1) G = 255; else G = 0;
			if(x % 3 == 2) B = 255; else B = 0;
			if(x == 0){G = 255; B = 255;}*/
			fwrite(&R,1,1,f);
			fwrite(&G,1,1,f);
			fwrite(&B,1,1,f);
		}


	fclose(f);
}
DataTif::~DataTif(){}
void DataTif::colorgradient(double x,double xmin,double xmax,unsigned char* R, 
							unsigned char* G,unsigned char* B){
    double q = (x-xmin)/(xmax-xmin);
	if(!useshell){
		if(q<0.00) 
			{*R = 255;				*G = 255;				*B =			 255;}
		if(q>=0.0) 
			{*R = q/0.25*255;		*G = 255;				*B =			   0;}
		if(q>=0.25) 
			{*R = 255;				*G = (0.5-q)/0.25*255;	*B =			   0;}
		if(q>=0.5) 
			{*R = 255;				*G = 0;					*B =(q-0.5)/0.25*255;}
		if(q>=0.75)
			{*R = (1.0-q)/0.25*255;	*G = 0;					*B =			 255;}
		if(q>1)    
			{*R = 0;				*G = 0;					*B =			   0;}
	}
	else{
        if( q <= cs){
            *R = 0;
            *G = (1-q/cs)*255;
            *G = 255;
            *B = 0;
        }
        else{
            if(q < ss)
                *R = *G = *B = (unsigned char) 0;
            else{
                q = q-cs;
                q = q - (int(q /ss)*ss);
                q = q / ss;
                q = 1-(sqrt(q));
                *R = (unsigned char)shellI*q;
                *G = (unsigned char)shellI*q;
                *B = (unsigned char)shellI*q;
                }

		}
	}
}
unsigned int DataTif::header(FILE* f){
	unsigned short isTiff = 42; unsigned int oIFD = 8;
	putc('I',f);putc('I',f);			//Little Endian
	fwrite(&isTiff,2,1,f);				//tiff-tag
	fwrite(&oIFD,4,1,f);				//offset zu Image File Directory
	return oIFD;						//offset ausgeben
}
unsigned int DataTif::IFD(FILE* f, unsigned int co, int width, int height,
						  short furtherIFD){

	unsigned short tag,typ,values; unsigned int count, value;

	unsigned int oBitsPerSample		= co + 2 + 12*12 + 4;
	unsigned int oResolution		= co + 2 + 12*12 + 4 + 3*2;
	unsigned int oStripByteCount	= co + 2 + 12*12 + 4 + 3*2 + 8; 
	unsigned int oStripOffset		= co + 2 + 12*12 + 4 + 3*2 + 8 + 4*height; 
	unsigned int oPictureData		= co + 2 + 12*12 + 4 + 3*2 + 8 + 4*height + 4*height;
	unsigned int oNextIFD			= co + 2 + 12*12 + 4 + 3*2 + 8 + 4*height + 4*height + 3*height*width;


	/*erster IFD, Anzahl tags*/
	typ = 12;
	fwrite(&typ,1,2,f);
   /* Width tag*/
	tag = 256; typ = 4; count = 1; value = (unsigned int) width;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Height tag*/
	tag = 257; typ = 4; count = 1; value = (unsigned int) height;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Bits per sample tag [Nutzt offset]*/
	tag = 258; typ = 3; count = 3; value = oBitsPerSample;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Compression flag, short int */
	tag = 259; typ = 3; count = 1; values = 1;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
   /* Photometric interpolation tag, short int */
	tag = 262; typ = 3; count = 1; values = 2;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
   /* Strip offset tag [Nutzt offset] */
	tag = 273; typ = 4; count = height; value = oStripOffset;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Sample per pixel tag, short int */
	tag = 277; typ = 3; count = 1; values = 3;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
   /* Rows per strip tag, short int */
	tag = 278; typ = 4; count = 1; value = 1;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Strip byte count [Nutzt offset] */
	tag = 279; typ = 4; count = height; value = oStripByteCount;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
   /* Resulution x [Nutzt offset]*/
	tag = 282; typ = 5; count = 1; value = oResolution;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
	/* Resulution y [Nutzt offset]*/
	tag = 283; typ = 5; count = 1; value = oResolution;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&value,4,1,f);
	/* Resolution unit */
	tag = 296; typ = 3; count = 1; values = 1;
	fwrite(&tag,2,1,f); fwrite(&typ,2,1,f);fwrite(&count,4,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
	/*Next IFD or end of file*/
	if(furtherIFD) value = oNextIFD;
	else		   value = 0;
	fwrite(&value,4,1,f);



	/*zusaetzliche IFD-Daten, die nicht in die IFD-Value-Bereiche gepasst haben*/
	values = 8; 						//Bits per sample tag
	fwrite(&values,2,1,f);fwrite(&values,2,1,f);fwrite(&values,2,1,f);
	value = 300;						//Resolution
	fwrite(&value,4,1,f);value = 1;fwrite(&value,4,1,f);
    value = (unsigned int)width*3;                    //StripByteCount
	for(int y = 0; y < height; y++)	fwrite(&value,4,1,f);
	for(int y = 0; y < height; y++){	//Strip Offset Tag
        value = oPictureData + y * (unsigned int) width*3;
		fwrite(&value,4,1,f);
	}
	return oNextIFD;
}
