﻿#include "array.h"

void alloc_array(double*** array, int dim1, int dim2){
    *array = alloc_array(dim1,dim2);
}
void alloc_array(double*** array, int dim1, int* dim2){
    *array = new double*[dim1];
    for(int i = 0; i < dim1; i++)
        (*array)[i] = new double[dim2[i]];
}
double** alloc_array(int dim1, int dim2){
    double **result = new double*[dim1];
    for(int i = 0; i < dim1; i++)
        result[i] = new double[dim2];
    return result;
}
int** alloc_iarray(int dim1, int dim2){
    int **result = new int*[dim1];
    for(int i = 0; i < dim1; i++)
        result[i] = new int[dim2];
    return result;
}

void free_array(double*** array, int dim1){
    if(*array != NULL){
        for(int i = 0; i < dim1; i++)
            free((*array)[i]);
        free(*array);
        *array = NULL;
    }
}
void scale(double* array, int dim, double factor){
    if(array != NULL){
        for(int i = 0; i < dim; i++)
            array[i] = array[i]*factor;
        }
}
void init_array(double** array, int dim1, int dim2, double value){
    if(array != NULL){
        for(int i = 0; i < dim1; i++)
            for(int j = 0; j < dim2; j++)
                array[i][j] = value;
    }
}
void init_array(double* array, int dim, double value){
    if(array != NULL)
        for(int i = 0; i < dim; i++)
            array[i] = value;
}
void init_array(int* array, int dim, int value){
    if(array != NULL)
        for(int i = 0; i < dim; i++)
            array[i] = value;
}
double max_array(double* array, int dim){
    double result = array[0];
    for(int i = 1; i < dim; i++)
        if(array[i]>result)
            result = array[i];
    return result;
}

double min_array(double* array, int dim){
    double result = array[0];
    for(int i = 1; i < dim; i++)
        if(array[i]<result)
            result = array[i];
    return result;
}
void sum(double a, double* x, double* b, double* y, int cpara){
    for(int i = 0; i < cpara; i++)
        y[i] = a*x[i]+b[i];
}
double sum(double* array, int dim){
    double result = 0;
    for(int i = 0; i < dim; i++)
        result += array[i];
    return result;
}

void clone(double** dest, double* src, int dim){
    *dest = new double[dim];
    copy(*dest,src,dim);
}
void copy(double* dest, double* src, int dim){
    for(int i = 0; i < dim; i++)
        dest[i] = src[i];
}

void sort(double* data,int s, int e){
    double sb;
    int l = s, r = e;
    double p = data[(s+e)/2];
    do{
        while(data[l] < p) l++;
        while(data[r] > p) r--;
        if(l<=r){
            sb = data[l]; data[l] = data[r]; data[r] = sb;
            l++;
            r--;
        }
    }while(l <= r);
    if(s < r) sort(data,s,r);
    if(l < e) sort(data,l,e);
}
void sort(double** data, int s, int e){
    int l = s, r = e;
    double* sb;
    double p = data[(s+e)/2][0];
    do{
        while(data[l][0] < p) l++;
        while(data[r][0] > p) r--;
        if(l<=r){
            sb = data[l]; data[l] = data[r]; data[r] = sb;
            l++;
            r--;
        }
    }while(l <= r);
    if(s < r) sort(data,s,r);
    if(l < e) sort(data,l,e);
}
double norm(double* array, int dim){
    double result = 0;
    for(int i = 0; i < dim; i++)
        result += array[i]*array[i];
    return sqrt(result);
}
void normalize(double* array, int dim){
    double sum = 0;
    for(int i = 0; i < dim; i++)
        sum += array[i];
    if(sum != 0)
        scale(array,dim,1./sum);
}
double mean(double* d, int istart, int iend){
    double result = 0;
    for(int i = istart; i <= iend; i++)
        result = result + d[i];
    return result/(iend-istart+1.);
}
long double coth(double x){
    return (exp(2*x)+1)/(exp(2*x)-1);
}
