#ifndef FOLD_H
#define FOLD_H
#include <QString>
#include <QPushButton>
#include <QLabel>
#include <QLineEdit>
#include <QGridLayout>
#include <QCheckBox>
#include <QFile>
#include <QMessageBox>
#include <cmath>

//! autonom class to fold raw moessbauer data
class Fold : public QWidget{
public:
    Fold(QString filename, QString inipath);
    ~Fold();
private:
     Q_OBJECT
    void init( QString inipath);        //!< load settings from file
    void autochannel();                 //!< seaches for best fold channel
    void load_data();                   //!< load data from filename-file
    int cc;                             //!< channel count
    int* data;                          //!< data, counts
    QLabel lblCS,lblalpha,lblvoltage,lblchnfold,lblautochn;
    QLineEdit editCS,editalpha,editvoltage,editchnfold,editautochn;
    QPushButton btnfold;
    QPushButton btncancel;
    double CS,alpha,voltage,chnfold;
    int autochn;
    QCheckBox useautochn;
    QString filename;
    QString inipath;
private slots:
    void execute_fold();
signals:
    void closes();
};

#endif // FOLD_H
