﻿#include "mainwindow.h"
#include "ui_mainwindow.h"


MainWindow::MainWindow(QWidget *parent, int argc, char *argv[]) :
    QMainWindow(parent),
    ui(new Ui::MainWindow){
    cfm = NULL;
    ui->setupUi(this);
    MoessSpectrum.setWindowTitle("Spectrum");
    MoessSpectrum.setVisible(true);
    MoessSpectrum.set_labels("Moessbauer Spectrum",
                              "Energy / (mm/s)",
                              "Intensity");
    EnergySpectrum.setWindowTitle("Secondary");
    EnergySpectrum.set_linewidth(2.);
    EnergySpectrum.setVisible(true);
    EnergySpectrum.set_labels("s",
                                  "ausgewählte Variable",
                                  "Energie / (mm/s)");

    connect(ui->actionAbsorbtionsspektrum_an_aus, SIGNAL(triggered()),this,SLOT(toggle_AbsorbtionPlot()));
    connect(ui->actionEnergieniveaus_anzeigen, SIGNAL(triggered()),this,SLOT(toggle_EnergyPlot()));
    connect(ui->actionAbsorbtionsspektrum_in_Zwischenablage_kopieren,SIGNAL(triggered()),this,SLOT(Absorbtion_to_clipboard()));
    connect(ui->actionEnergieniveaus_in_Zwischenablage_kopieren,SIGNAL(triggered()),this,SLOT(Energy_to_clipboard()));
    connect(&MoessSpectrum,SIGNAL(keypressed(QKeyEvent*)),this,SLOT(child_keyevent(QKeyEvent*)));
    connect(&EnergySpectrum,SIGNAL(keypressed(QKeyEvent*)),this,SLOT(child_keyevent(QKeyEvent*)));
    connect(ui->actionOpen_anyfile,SIGNAL(triggered()),this,SLOT(open_dialog()));
    connect(ui->actionClose,SIGNAL(triggered()),this,SLOT(close()));
    connect(ui->actionRefine_folder,SIGNAL(triggered()),this,SLOT(folder_refine()));
    connect(ui->actionGenerate_folder_Tiff,SIGNAL(triggered()),this,SLOT(folder_to_tiff()));
    connect(ui->actionAdd_noise,SIGNAL(triggered()),this,SLOT(add_noise()));
    connect(ui->actionGnerate_linearized_velocity_data,SIGNAL(triggered()),this,SLOT(linearize_data()));



    //QString cfmfile2("D:\Proben\\CuFeAs-3rd\\afmBexAnalysis - Kopie.mbs");
    //QString cfmfile2("D:\\Proben\\CuFeAs-Bex\\Aonly-MEM.mbs");
    //QString cfmfile2("D:\\Proben\\FeSe-GF419\\MEM.mbs");
    //QString cfmfile2("D:\\Proben\\FeSe-GF419\\Gaussian.mbs");
    //QString cfmfile2("D:\\Proben\\Na0.7La0.3Fe2As2\\OderParameter2014\\B0.mbs");
    //QString cfmfile2("D:\\Proben\\CuFeAs-2nd\\DebyeFit\\CombinedDebyeFit.mbs");
    //QString cfmfile2("D:\\Proben\\Na0.7La0.3Fe2As2\\Auswertung2014_TI - 6,3.mbs");
    //QString cfmfile2("D:\\Proben\\CuFeSb\\ExternalField\\Auswertung-FM-AFM.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\HesseRuebartsch\\spectrum.mbs");
    //QString cfmfile2("D:\\Proben\\Ferrocen77mg\\300.0\\Ferrocen77mg_2802_1502.mbs");
    //QString cfmfile2("D:\\Theoretische Ueberlegungen\\Moessfit\\Errors\\Vzz50Eta0,5beta54,7.mbs");
    //QString cfmfile2("D:\\Proben\\FeSe0.88S0.12-LiOH-intercalated\\Analysis.mbs");
    //QString cfmfile2("/home/musr/Sirko/Mossbauer/FeSe0.88S0.12-LiOH-intercalated/Analysis (copy).mbs");
    //QString cfmfile2("/home/musr/Sirko/Mossbauer/FeSe0.88S0.12-LiOH-intercalated/Analysis.mbs");
    //QString cfmfile2("C:\\Users\\User\\c++\\Moessfit\\release\\default.mbs");
    //QString cfmfile2("/home/musr/Sirko/Mossbauer/FeS-LiOH-intercalated/10,1K-thickAbsorber.mbs");
    //QString cfmfile2("D:\\Proben\\FeSe-LiOH-intercalated\\DebyeFit\\QuadDopplerFit.mbs");
    //QString cfmfile2("D:\\Proben\\FeS-LiOH-intercalated\\ThickAbsorber.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\AnyFit\\OP.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\AnyFit\\NicolasDynVzzVzz.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\DynTestcase\\MLR.mbs");
    //QString cfmfile2("\\\\pfpl45\\musr\\nicolas\\Mossbauer\\PyPh(FeCp2)2(1+)\\DebyeInnerD_Debug.mbs");
    //QString cfmfile2("D:\\Theoretische Ueberlegungen\\SigmaSC - credibility\\simulate.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MagTest.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\UnfoldedData\\analysis.mbs");
    //QString cfmfile2("/home/musr/Sirko/MossbauerSirko/TestcaseCosineSmearing/test.mbs");
    //QString cfmfile2("D:\\Proben\\La2O2Fe2OS2\\RT.mbs");
    //QString cfmfile2("D:/Veroeffentlichungen/La2(O,F)3Fe2(S,Se)/Fits/DebyeFit.mbs");
    //QString cfmfile2("D:\\Theoretische Ueberlegungen\\Moessfit\\BexSpectra\\buf.mbs");
    //QString cfmfile2("/home/musr/Sirko/MossbauerSirko/LiCuFe2(V04)3/skewtest.mbs");
    //QString cfmfile2("/home/musr/Sirko/MossbauerSirko/TlFe(MoO4)2/SchiefeDistr.mbs");
    //QString cfmfile2("/home/musr/Sirko/MossbauerSirko/LiCuFe2(V04)3/SchiefeDistr.mbs");
    //QString cfmfile2("D:/Theoretische Ueberlegungen/Moessfit/Helimagnet/theta(alpha).mbs");
    //QString cfmfile2("D:\\Veroeffentlichungen\\LaFe(As,P)O\\OP-Fit\\scAnalysis.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\Skyrmion\\buf.mbs");
    //QString cfmfile2("D:\\Proben\\Fe3PO4O3\\AnalysisSkyrmion.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\SHpLev\\Analysis.mbs");
    //QString cfmfile2("D:\\Proben\\NaCuFe2(VO4)3\\SchiefeDistr.mbs");
    //QString cfmfile2("C:\\Users\\test\\Desktop\\MoessfitTestcase\\DynTestcase\\CheckStatics.mbs");
    QString cfmfile2("nothing");

    if(QFileInfo(cfmfile2).exists()){
        argc = 2;
        load_from_mbs(cfmfile2);
    }
    //cfm->save_linear_v_spectra();

    MoessSpectrum.show_residuum();

    if(0){
        QString testangles;
        MoessCalc* mc = new MoessCalc;
        double theta[2]={30,-30};
        for(double Bex = 0; Bex < 20; Bex += 0.1){
            mc->afm_flipflop(Bex,-5,16,90,&(theta[0]),&(theta[1]));
            testangles.append(QString("%1\t%2\t%3\n").arg(Bex).arg(theta[0]).arg(theta[1]));
        }
        QApplication::clipboard()->setText(testangles);
    }

    if(0){
        double Iafm[512];
        double params[11] = {1.0,2.0,3.0,1,12,60,0,0.15,200,50,20};
        //{Bafm, BA, BJ, Bex, Vzz, theta0, CS, omega, A, N,Nvzz}
        double v[512];
        MoessCalc* mc = new MoessCalc;
        for(int i = 0; i < 512; i++)
            v[i] = -2.5*cos(2.*M_PI*i/1024.);
        for(double BJ = 1.8; BJ < 2; BJ += 0.4)
            //for(double BA = 0; BA < 11; BA += 5)
                for(double Bex = 0; Bex < 6.4; Bex += 0.3){
                    double BA = 12;
                    params[3] = Bex;
                    params[2] = BJ;
                    params[1] = BA;
                    mc->get_afm_Powder_spectrum(Iafm,512,v,params);
                    QString foldername = QString("%1-%2-%3").arg(Bex,0,'f',1,'0').arg(BA,2,'f',0,'0').arg(BJ,2,'f',0,'0');
                    QString filename = QString("D:\\Theoretische Ueberlegungen\\Moessfit\\afmBexSimulation\\");
                    QDir(filename).mkdir(foldername);
                    FILE *f = fopen(filename.append(foldername).append("\\data.fld").toLocal8Bit(),"w");
                    for(int i = 0; i < 512; i++)
                        fprintf(f,"%f\t%f\n",v[i],1000+Iafm[i]);
                    fclose(f);
                }
    }

    ui->verticalLayout->setSizeConstraint(QLayout::SetMinimumSize);
    centralWidget()->setLayout(ui->verticalLayout);

    this->setFocus();
    //char filename[] = "D:\\Proben\\CuFeAs-2nd\\2.1\\CuFeAs_2102_0621.dat";
    //argv[1] = filename;
    //argc = 2;
    if(argc > 1){
        QRegExp fldexpr("*.fld");
        fldexpr.setPatternSyntax(QRegExp::Wildcard);
        if(fldexpr.exactMatch(QString(argv[1]))){
            QStringList flds;
            for(int i = 1; i < argc; i++)
                flds.append(QString(argv[i]));
            if(!load_from_fld(flds)){
                QMessageBox msgBox;
                msgBox.setText(QString("%1 couldn't be opened by MoessFit.")
                               .arg(argv[1]));
                msgBox.exec();
                start_empty();
            }
        }
        QRegExp mbsexpr("*.mbs");
        mbsexpr.setPatternSyntax(QRegExp::Wildcard);
        if(mbsexpr.exactMatch(QString(argv[1])))
            if(!load_from_mbs(QString(argv[1]))){
                QMessageBox msgBox;
                msgBox.setText(QString("%1 couldn't be opened by MoessFit.")
                               .arg(argv[1]));
                msgBox.exec();
                start_empty();
            }
        QRegExp ws5expr("*.ws5");
        ws5expr.setPatternSyntax(QRegExp::Wildcard);
        QRegExp datexpr("*.dat");
        datexpr.setPatternSyntax(QRegExp::Wildcard);
        if(ws5expr.exactMatch(QString(argv[1]))
        || datexpr.exactMatch(QString(argv[1]))){
            Fold* f = new Fold(QString(argv[1]),
                                      QApplication::applicationDirPath()
                                      .append("/fold.ini"));
            connect(f,SIGNAL(destroyed()),this,SLOT(close()));
            ui->verticalLayout->addWidget(f);
        }
    }
    else
        start_empty();
    this->lower();

    MoessCalc mc;
    double E[8][2],eT[2];

    /*FILE* file=fopen("C:\\Users\\test\\Desktop\\MoessfitTestcase\\Intesities.txt","w");
    for(double B = 0.01; B < 100; B*=1.2){
        mc.set_parameters(B,50,54.73561031724530000000,0,0);
        mc.calc();
        // get data
        int k =0;
        for(int i = 0; i < 2; i++)
            for(int f = 0; f < 4; f++){
                E[k][0] = mc.get_Egamma(f,i);
                E[k][1] = mc.I(f,i);
                k++;
            }
        // sort data
        for(int i = 0; i < 8; i++)
            for(int j = i ; j < 7; j++)
                if(E[j][0] < E[j+1][0]){
                    eT[0] = E[j][0];eT[1] = E[j][1];
                    E[j][0] = E[j+1][0];E[j][1] = E[j+1][1];
                    E[j+1][0] = eT[0];E[j+1][1] = eT[1];
                }

        // print
        for(int i = 0; i < 8; i++)
            fprintf(file,"%f\t",E[i][1]);
        fprintf(file,"\n");
    }
    fclose(file);*/

    //int maxs = 80; // 3min
    /*int maxs = 250;
    char* files[501];
    QString filess[501];

    for(int vzz=-maxs; vzz<=maxs;vzz++){
        filess[vzz+maxs] = QString("C:\\Users\\User\\Desktop\\Neuer Ordner\\chi%1.txt").arg(vzz);
        files[vzz+maxs] = new char[filess[vzz+maxs].toLocal8Bit().size()];
        strcpy(files[vzz+maxs], filess[vzz+maxs].toLocal8Bit().data());
    }
    DataTif(&(files[0]),501,"C:\\Users\\User\\Desktop\\Neuer Ordner\\Vzz-eta-beta-correlation.tif",
            true,100,1,150);*/

    // Test Paraboloid
    /*double x[26][3] =
    {{0.3844,1.348999,-1.6521},
    {1.265137,-0.237305,1.6969},
    {-0.00415,-1.813477,-1.770997},
    {-0.317261,1.69104,1.19812},
    {0.006714,1.348023,-1.587403},
    {1.816529,-1.629151,-1.051026},
    {-0.764771,1.803345,-0.833863},
    {-1.145874,-1.44458,-0.060303},
    {1.112061,1.492432,-1.368409},
    {-1.225708,0.07666,1.657105},
    {-0.858155,-0.785645,-1.139038},
    {-0.009766,-0.098389,-0.343872},
    {-0.449585,1.224732,0.30603},
    {0.676514,0.043945,-1.517945},
    {1.5094,-1.609131,1.879151},
    {1.484742,-0.573975,1.003907},
    {-1.185059,0.621582,0.406616},
    {-0.977539,0.544312,-0.30603},
    {-0.095215,-0.987793,-0.133423},
    {0.443359,0.609131,-0.319214},
    {0.167847,-0.310791,1.935303},
    {-1.715332,0.217651,-0.000122},
    {-1.868531,-0.81604,-0.437378},
    {-0.205811,1.057495,0.884155},
    {1.811524,-0.16394,-0.94751},
    {0.897583,-1.847413,1.66211}};
    double* X[26];
    //for(int i= 0; i < 26; i++)
    //    X[i] = &(x[i][0]);

    double y[26] =
    {1.357994496,
    3.4285495998,
    9.4308250937,
    6.7491171829,
    1.6081916399,
    7.3017875215,
    4.6089536995,
    4.6989202971,
    2.3218860185,
    0.934341372,
    3.6569538024,
    0.0920802358,
    2.7640242285,
    0.4194971774,
    5.80853996,
    3.0216718397,
    1.6534565839,
    1.2584831056,
    1.6967268173,
    0.5254009281,
    1.0930465797,
    2.4540072172,
    5.0860870596,
    2.8354997515,
    2.0100656861,
    4.7580613936};
    double fxy[6];

    //paraboloid(X,y,3,26,fxy);*/
    /*
    double a = 2;

    double ps[6]={0.5,0.7,0.9,0.95,0.99,0.6827};
    QString pdf;
    for(double i = 1; i < 25; i+=0.1){
        pdf.append(QString("\n%1\t").arg(i));
        for(int ip = 0; ip < 6; ip++)
            pdf.append(QString("%1\t").arg(gsl_cdf_chisq_Pinv(ps[ip],i)));
    }
    QApplication::clipboard()->setText(pdf);
    */
    /*QDir folder("D:\\Proben\\FeS-LiOH-intercalated\\KleinerKryo\\300,2K");
    folder.setNameFilters(QStringList("*.fld"));
    folder.setFilter(QDir::Files);
    folder.setSorting(QDir::Time);
    QFile newfld(QString("D:\\Proben\\FeS-LiOH-intercalated\\KleinerKryo\\300,2K\\newfld"));
    newfld.open(QFile::WriteOnly);
    QTextStream out(&newfld);
    double dold[512];
    double dnew[512];
    init_array(dnew,512,0);
    for(int i = folder.entryList().count()-1; i >= 0; i--){
        copy(dold,dnew,512);
        QFile file(folder.absoluteFilePath(folder.entryList().at(i)));
        file.open(QFile::ReadOnly);
        double v;
        QTextStream in(&file);
        in>>v;
        for(int j = 0; j < 512; j++)
            in >> v >> dnew[j];
        for(int j = 0; j < 512; j++)
            if(dold[j]> dnew[j])
                if(dold[j]> dnew[j] + 1e6)
                    out << dnew[j]-dold[j]+2e6 << "\t";
                else
                    out << dnew[j]-dold[j]+1e6 << "\t";
            else
                out << dnew[j]-dold[j] << "\t";
        out << "\n";
    }*/

    //CrystalFields cf(380.38*1e-12/sqrt(2),922e-12,40,10);
    /* // FeSe, Se-vacancy field gradient calculation
    CrystalFields cf(3.76932,5.4861,8,8);
    QString pdf;
    double rho[50];
    double SeVacancy = 0.2;
    double V[6];
    //for(double z = 0; z < 0.5; z += 0.01){
    for(SeVacancy = 0; SeVacancy < 1.01; SeVacancy+=0.02){
        QFile newfld(QString("C:\\Users\\test\\Desktop\\Hesse.txt"));
        newfld.open(QFile::Append);
        QTextStream out(&newfld);
        init_array(rho,50,0);
        double Vzzeff = 0;
        for(int i = 0; i < 10000; i++){
            cf.Vzz_FeSe(2,104.5,SeVacancy,1,V);
            double EW[3],EV[9];
            cf.eigen_3x3(V,EW,EV);
            Vzzeff = EW[0] * sqrt(1+(EW[1]-EW[2])*(EW[1]-EW[2])/EW[0]/EW[0]/3);
            if(int(Vzzeff*2.5) < 50)
                rho[int(Vzzeff*2.5)]++;
        }
        pdf.append(QString("%1\t").arg(SeVacancy));
        out << SeVacancy << "\t";
        //out << z << "\t" << Vzzeff/10000. << "\r\n";
        normalize(rho,50);
        for(int i = 0; i < 50; i++)
            out << rho[i] << "\t";//pdf.append(QString("%1\t").arg(rho[i]));
        out << "\r\n";//pdf.append("\n");
        newfld.close();
    }*/
    //QApplication::clipboard()->setText(pdf);/**/
    //MoessCalc().Test();
    QString cbs;
    /*MoessCalc mc0;
    double X[4] = {-4,1,-3,2};
    double Y[4] = {0,1,3,0};
    double xt,yt;
    for(double i = 0; i < 101; i++){
        //double t = 1.*i/100;
        //mc0.Bezier(X,Y,4,t,&xt,&yt);
        //cbs.append(QString("%1\t%2\t%3\n").arg(t).arg(xt).arg(yt));
        xt = X[0]*(100-i)/100+X[3]*i/100;
        yt = mc0.Bezier_y(X,Y,4,xt);
        cbs.append(QString("%1\t%2\n").arg(xt).arg(yt));
    }
    QApplication::clipboard()->setText(cbs);*/

    /*MoessCalc mct;
    cbs.append("\t");
    for(double N = 0; N < 5; N+=0.01)
        cbs.append(QString("%1\t").arg(N));
    for(double alpha = 0; alpha < 91; alpha++){
        cbs.append("\n");
        cbs.append(QString("%1\t").arg(alpha));
        for(double N = 0; N < 5; N+=0.01)
            cbs.append(QString("%1\t").arg(mct.RechtsOverLinks(alpha/180*M_PI,N)));
    }
        QApplication::clipboard()->setText(cbs);*/
    //run_test_suite();
    /*nuclid n[4];
    n[0].gamma = 0.9596; n[0].I = 1.5; n[0].x = 0;   n[0].y = 0;   n[0].z = 0.295;
    n[1].gamma = 0.9596; n[1].I = 1.5; n[1].x = 0.5; n[1].y = 0.5; n[1].z = 0.705;
    n[3].gamma = 1.536;  n[3].I = 1.5; n[3].x = 0;   n[3].y = 0;   n[3].z = 0.705;
    n[4].gamma = 1.536;  n[2].I = 1.5; n[2].x = 0.5; n[2].y = 0.5; n[2].z = 0.295;
    QApplication::clipboard()->setText(QString("sigma: %1")
        .arg(sqrt(MuSR()
             .sigma_nuclear_tetragonal(4,n,3.7442,5.8925,1,0.5,0,0.3))));*/
    /*for(double a = 0; a < 100; a = a*1.05+0.005){
        cbs.append(QString("%1\t").arg(a));
        for(int xi = 0; xi <= 180; xi++){
            double theta = xi*0.6;
            MoessCalc().fm_flip(a,-1,xi,&theta);
            //if(theta>180)
            //    theta = 360 - theta;
            cbs.append(QString("%1\t").arg(qAbs(theta)));
        }
        cbs.append("\n");
    }
    */
    //CosSmearing cs1(0.0001,1,1,2,1);
    //CosSmearing cs2(0.2,1,1,2,1);
    //CosSmearing cs3(0.4,1,1,2,1);
    //CosSmearing cs4(0.6,1,1,2,1);
    //CosSmearing cs5(0.8,1,1,2,1);
    /*CosSmearing cs6(1,1,2,2,1);
    QString cbs = QString("Result:%1\n").arg(cs6.P(2.5,6,5));
    double integral = 0;
    for(double v=0; v < 10; v += 0.01){
        //cbs.append(QString("%7\t%1\t%2\t%3\t%4\t%5\t%6\n").arg(cs1.rho(v,1)).arg(cs2.rho(v,1)).arg(cs3.rho(v,1))
        //                                              .arg(cs4.rho(v,1)).arg(cs5.rho(v,1)).arg(cs6.rho(v,1)).arg(1-v));
        integral += cs6.P(v-0.005,v+0.005,5);
        cbs.append(QString("%2\t%1\t%3\n").arg(integral).arg(v).arg(cs6.P(0,v+0.005,5)));
    }

    // CALULATING DIPOLE FIELDS ###############################################
   double B[3];

   //MuSR m;
   CrystalFields m(0,0,0,0);
   //double ca = 3.7442*1.4142; // CuFeAs
   //double ca = 5.506; // Ca-122
   //double ca = 5.43; // LaNa-122
   double ca = 3.99757*1.414213; // La1111 x=0.4
   //double ca = 4.050*1.4142*0.995;// Sr4Sc2O6.0Fe2As2
   //ca = 4;
   //double ca = 5.3;        // FeSe
   //double ca = 5.42;        // FeTe
   //double cz = 5.8925;       // CuFeAs
   //double cz = 5.87;  // Ca-122
   //double cz = 6.13;  // LaNa-122
   //double cz = 8.709;  // L1111
   double cz = 8.584547;  // L1111 x=0.4
   //double cz = 15.809*0.995;        // Sr4Sc2O6.0Fe2As2
   //double cz = 5.45;        // FeSe
   //double cz = 6.26;        // FeTe
   double cb = ca;//5.45;
   double y = cb*1./4.;
   double lattice[15][3]={{5.506,5.45,5.87},
                          {5.615,5.572,6.214},
                          {5.706,5.679,8.709},
                          {5.589,5.569,6.992},
                          {5.589,5.569,6.992},
                          {5.537,5.505,6.025},
                          {5.552293,5.495464,6.130553},
                          {5.566844,5.505966,6.136702},
                          {5.616,5.587,8.557},
                          {5.637,5.606,8.597},
                          {5.663,5.633,8.644},
                          {5.4181350001638,5.34996990645742,6.264},
                          {5.42209479813845,5.35138412001979,6.257},
                          {5.69892710297298,5.69892710297298,15.729955},
                          {5.39,5.43,6.13}};
   //for(int i = 0; i < 15; i++){
   //for(double z=0; z < cz*1.005; z+=cz*0.01){
   //     for(double x=0; x < ca*1.005; x+=ca*0.01){
    //for(int i = 0; i < 11; i++){
    //    for(double z = 0.6; z < 1 ;z++){
   double x = 0.25*ca;
   double z = 0.08*cz;
   for(double h=0; h<1; h+=0.001){
       z = h*cz;
       m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,bicolinearAFM);
       double Btot = sqrt(B[0]*B[0]+B[1]*B[1]+B[2]*B[2]);
       cbs.append(QString("%1\t%2\n").arg(h).arg(Btot));
   }
   QApplication::clipboard()->setText(cbs);*/
   /*for(double dtheta = 0; dtheta < 90.5; dtheta++){
       for(double dphi = 0; dphi < 90.5; dphi++){
    //    ca = LP[i][0];
    //    cb = LP[i][1];
    //    cz = LP[i][2];
       //ca = lattice[i][0];
       //cb = lattice[i][1];
       //cz = lattice[i][2];
            B[0] = B[1] = B[2] = 0;
            //x = 0.25*ca;
            //y = cb*1./4.;
            //x = 0;
            //z= 0.08*cz;
            //double z = 0.6;
            //dy = cb/4;
            //z = 0.09*cz;    // Maeter   1111
            //z = 0.072*cz;    // de Renzi   1111
            //z = 0.09*cz;    // Materne  122
            //z = 0.16*cz;    // Bendele 11 FeSe
            //z = 0.245*cz;    // Lamura 11 FeTe
            //m.add_dipol(x,dy,z, magm,theta,phi,B);
            //m.add_dipol(x,dy,z-cz,magm,theta,phi,B);
            //m.add_dipol(0.5*ca-x,dy,z,-magm,theta,phi,B);
            //m.add_dipol(0.5*ca-x,dy,z-cz,-magm,theta,phi,B);
            //m.add_dipol(0.5*ca-x,0,0.5*cz-z,1,M_PI*0.5,0,B);
            m.set_canting(dtheta,dphi);
            m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,stripeAFM);
            double Btot = sqrt(B[0]*B[0]+B[1]*B[1]+B[2]*B[2]);
            //if(i == 11 || i == 12)
            //    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,0.245*cz,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,bicolinearAFM);
            //else
            //    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,stripeAFM);
            //cbs.append(QString("%1\t%2\t%5\t%3\t%4\n").arg(x/ca).arg(z/cz).arg((x+0.05*B[0]/Btot)/ca).arg((z+0.05*B[2]/Btot)/cz).arg(Btot));
            cbs.append(QString("%1\t").arg(Btot*135.5));
        }
        cbs.append("\n");
        // 0,15490452774484828 @ FeTe theta=3/4*pi
        // 0,24266304971513952 @ FeTe theta=1/4*pi
        // 0,32947765132054468 @ FeSe bendele
   }
   //}
    QApplication::clipboard()->setText(cbs);
    if(0){double Btot;
    double x = 0.25 * ca;
    double z = 0.08 * cz;
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,stripeAFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,bicolinearAFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,aFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,cFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,stripeAFM_c_axis);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),true,checkerboard);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),false,stripeAFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),false,bicolinearAFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),false,aFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),false,cFM);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),false,stripeAFM_c_axis);
    cbs.append(QString("%1\n").arg(Btot));
    Btot = m.B_dipol_pnictide(ca,cb,cz,x,y,z,1,10,10,7,&(B[0]),&(B[1]),&(B[2]),false,checkerboard);
    cbs.append(QString("%1\n").arg(Btot));
    }

    *//*// CALULATING FIELD GRADIENTS #############################################
    CrystalFields m(0,0,0,0);
    //double ta = 113.7/180.*M_PI; //Fe(Se,Te)
    //double a = 3.8; //Fe(Se,Te)
    //double c = 6.0; //Fe(Se,Te)
    double ta = 101/180.*M_PI; //CuFeAs
    double a = 3.734; //CuFeAs
    double c = 5.8452; //CuFeAs
    //double a = 3.89;    //Ca122
    //double ta = 101/180.*M_PI; //Ca122
    //double c = 11.72;    //Ca122
    ta = 111.8/180.*M_PI;
    double hAs = a/2./tan(ta/2);
    double hLi = (1-0.6780) * c;
    //for(double hLi = 1.4; hLi < c; hLi+= 0.1){
    //for(int imax = 0; imax < 30; imax++){
    int imax = 8;
    double Vij[6] = {0,0,0,0,0,0};
    for(int i=-imax; i < imax+1; i++)
        for(int j=-imax; j < imax+1; j++)
            for(int k = -imax; k < imax+1; k++){
                // As ions, 3+
                m.add_point_charge( a/2.+i*a,  0.0+j*a, a/2./tan(ta/2)+k*c,-1.5,Vij);
                m.add_point_charge(  0.0+i*a,-a/2.+j*a,-a/2./tan(ta/2)+k*c,-1.5,Vij);
                m.add_point_charge(-a/2.+i*a,  0.0+j*a, a/2./tan(ta/2)+k*c,-1.5,Vij);
                m.add_point_charge(  0.0+i*a, a/2.+j*a,-a/2./tan(ta/2)+k*c,-1.5,Vij);
                // Fe ions, 2+
                //m.add_point_charge( a/2.+i*a, a/2.+j*a,                k*c, 0.5,Vij);
                //m.add_point_charge( a/2.+i*a,-a/2.+j*a,                k*c, 0.5,Vij);
                //m.add_point_charge(-a/2.+i*a, a/2.+j*a,                k*c, 0.5,Vij);
                //m.add_point_charge(-a/2.+i*a,-a/2.+j*a,                k*c, 0.5,Vij);
                //m.add_point_charge(      i*a,      j*a,                k*c, 2.0,Vij);
                // Li/Cu ions, 1+
                //m.add_point_charge( a/2.+i*a,  0.0+j*a,           -hLi+k*c, 0.5,Vij);
                //m.add_point_charge(  0.0+i*a,-a/2.+j*a,            hLi+k*c, 0.5,Vij);
                //m.add_point_charge(-a/2.+i*a,  0.0+j*a,           -hLi+k*c, 0.5,Vij);
                //m.add_point_charge(  0.0+i*a, a/2.+j*a,            hLi+k*c, 0.5,Vij);
                //Ca122 Fe
                //m.add_point_charge( a/2.+i*a, a/2.+j*a,                k*c, 2.0,Vij);
                //m.add_point_charge(      i*a,      j*a,                k*c, 2.0,Vij);
                //m.add_point_charge( a/2.+i*a, a/2.+j*a,          0.5*c+k*c, 2.0,Vij);
                //m.add_point_charge(      i*a,      j*a,          0.5*c+k*c, 2.0,Vij);
                //Ca122 As
                //m.add_point_charge( a/2.+i*a,  0.0+j*a,      hAs+k*c,-3,Vij);
                //m.add_point_charge(  0.0+i*a,-a/2.+j*a,     -hAs+k*c,-3,Vij);
                //m.add_point_charge( a/2.+i*a,  0.0+j*a,0.5*c-hAs+k*c,-3,Vij);
                //m.add_point_charge(  0.0+i*a,-a/2.+j*a,0.5*c+hAs+k*c,-3,Vij);
                //Ca122 Ca
                //m.add_point_charge( a/2.+i*a, a/2.+j*a,      0.25*c+k*c, 2,Vij);
                //m.add_point_charge(  0.0+i*a,  0.0+j*a,     -0.25*c+k*c, 2,Vij);
            }
    double EW[3],EV[9];
    m.eigen_3x3(Vij,EW,EV);
    for(int i = 0; i < 3; i++){
        cbs.append(QString("%1\t").arg(EW[i]));
        for(int j = 0; j < 3; j++)
            cbs.append(QString("%1\t").arg(EV[i*3+j]));
    }
    cbs.append("\n");*/

    // Transmission integral simulation
    /*double v[512];
    double I[512];
    double p[10] = {0,0,0,0,0,0,0.08,1,0,0};
    for(int i = 0; i < 512; i++)
        v[i] = -8.5 + i*17./512.;
    for(double t = 0.001; t < 3000; t *=1.5){
        QString filename = QString("D:\\Theoretische Ueberlegungen\\Moessfit\\TransmissionIntegral\\Singlett\\%1.fld").arg(t);
        //QString filename = QString("D:\\Theoretische Ueberlegungen\\Moessfit\\TransmissionIntegral\\Doublett\\%1.fld").arg(t);
        //QString filename = QString("D:\\Theoretische Ueberlegungen\\Moessfit\\TransmissionIntegral\\Sextett\\%1.fld").arg(t);
        MoessCalc m;
        m.get_Powder_spectrum(I,512,v,p);
        for(int i = 0; i < 512; i++)
            I[i] += 1e7;
        m.TransmissionIntegral(I,v,512,1,1e7,t,0.0515,0.0485,0.5);
        FILE *f = fopen(filename.toLocal8Bit(),"w");
        for(int i = 0; i < 512; i++)
            fprintf(f,"%f\t%f\n",v[i],I[i]);
        fclose(f);
    }
    for(double BTc=0.01; BTc < 7; BTc*=1.1){
        for(double ft = 0; ft < 1.05; ft+=0.1)
            cbs.append(QString("%1\t%2\t%3\n").arg(BTc).arg(ft).arg(mc.Mmf(BTc,1,0.5,ft,1,2)));
    }*/
    // CALULATING Fe3Po4O3 FIELD GRADIENTS #############################################
    /*CrystalFields m(0,0,0,0);
    double EW[3],EV[9];
    for(int i = 1; i < -50; i++){
        m.Fe3PO4O3_Vii(i,EW,EV);
        for(int i = 0; i < 3; i++){
            cbs.append(QString("%1\t").arg(EW[i]));
            for(int j = 0; j < 3; j++)
                cbs.append(QString("%1\t").arg(EV[i*3+j]));
        }
        cbs.append("\n");
    }
    cbs = m.Fe3PO4O3_Vii(1,EW,EV);*/

   // CALULATING Fe3Po4O3 DIPOL FIELD #############################################
    CrystalFields cf(0,0,0,0);
    double B[3],Btot;
    double ca = 8.006;
    double cc = 6.863;
    double P[3] = {90,-0.5833333333333,1};              // theta, phi, lambda_z
    /*for(double Theta = 0; Theta <= 180; Theta++){
        for(double Phi = 0; Phi <= 360; Phi++)
            cbs.append(QString("%1\t").arg(cf.TriangleDipoleFieldchange(4.2,46.5,1.8073061061,Theta,Phi)));
        cbs.append("\n");
    }*/

    /*for(int z=0; z<100;z++){
        for(int x=0; x<100;x++){
            Btot = cf.Fe3PO4O3_dipol(ca,cc,
                                     -ca*1.5*x/99.,ca*sin(M_PI/3)*x/99.,cc*z/99.,
                                     //ca*x/99.,0,cc*z/99.,
                                     //ca*(-x/99.-0.5*z/99.),ca*sin(M_PI/3.)*z/99.,cc*(1./3.-0.05),
                                     4,5,5,5,
                                     &(B[0]),&(B[1]),&(B[2]),
                                     P);
            double Bz = B[2];
            //double Bz = B[1];
            double Bx = B[0]*cos(M_PI*5./6.)+B[1]*sin(M_PI*5./6.);
            //double Bx = B[0];
            //cbs.append(QString("%1\t%2\t%3\t%4\t%5\n").arg(-x/99.-0.5*z/99.).arg(z/99.)
            cbs.append(QString("%1\t%2\t%3\t%4\t%5\n").arg(x/99.).arg(z/99.)
                                                      .arg(Btot)
                                                      .arg(atan2(Bz,Bx)).arg(sqrt(Bx*Bx+Bz*Bz)/qMax(1e-7,Btot)));

        }
        cbs.append("\n");
    }*/
    /*
    double b0;
    for(int z = 0; z < 101; z++){
        for(int theta = 0; theta < 101; theta++){
            P[0] = 0.9*theta;
            P[1] = 0;
            P[2] = 1.;
            Btot = cf.Fe3PO4O3_dipol(ca,cc,
                                     //-ca*1.5*1./3.,ca*sin(M_PI/3)*1./3.,cc*(1./3.-0.01*z),
                                     0,0,0.01*z*cc,
                                     //ca*x/99.,0,cc*z/99.,
                                     4,7,7,7,
                                     &(B[0]),&(B[1]),&(B[2]),
                                     P);
            //if(dlambda == 0) b0 = Btot;
            cbs.append(QString("%1\t").arg(Btot));
            //cbs.append(QString("%1\t%2\t%3\t%4\n").arg(Btot).arg(B[0]).arg(B[1]).arg(B[2]));
        }
        cbs.append("\n");
    }*/
    /*MoessCalc mct;
    double theta[90];
    mct.skyrmion_theta(theta,22,0.073,70,2,11,8.006);
    for(int i = 0; i <90; i++)
        cbs.append(QString("%1\t").arg(theta[i]));*/
    //QApplication::clipboard()->setText(cbs);
   /*QApplication::clipboard()->setText(cf.Fe3PO4O3_dipol(8.006,6.863,
                                                        0,0,0,0.7,1,1,1,NULL,NULL,NULL));*/

    //runlog_merge rlm("D:\\Proben");
    //rlm.save("D:\\Proben\\CuFeAs-NeutronSample\\runlo_merged.txt");
}


MainWindow::~MainWindow(){
    delete ui;
}
void MainWindow::keyPressEvent(QKeyEvent *event){
    switch(event->key()){
        case Qt::Key_F:
            if(cfm != NULL){
                cfm->fit();
            }
            break;
        case Qt::Key_V:
            if(Qt::AltModifier && cfm != NULL){
                cfm->plot(&MoessSpectrum,&EnergySpectrum);
                EnergySpectrum.raise();
                MoessSpectrum.raise();
            }
            break;
        case Qt::Key_E:
            cfm->errors();
            break;
        case Qt::Key_U:
        case Qt::Key_F5:
        case Qt::Key_R:
            load_from_mbs(cfmfile);
            break;
    }
}
void MainWindow::toggle_EnergyPlot(){
    if(EnergySpectrum.isVisible())
        EnergySpectrum.setVisible(false);
    else{
        EnergySpectrum.setVisible(true);
    }
}
void MainWindow::toggle_AbsorbtionPlot(){
    if(MoessSpectrum.isVisible())
        MoessSpectrum.setVisible(false);
    else{
        MoessSpectrum.setVisible(true);
    }
}
void MainWindow::Absorbtion_to_clipboard(){
    MoessSpectrum.data_to_clipboard();
}
void MainWindow::Energy_to_clipboard(){
    EnergySpectrum.data_to_clipboard();
}
void MainWindow::start_empty(){
    // check for fld file
    QString defaultfld = QApplication::applicationDirPath().append("/default.fld");
    if(!QFile(defaultfld).exists()){
        FILE* f = fopen(defaultfld.toLocal8Bit().data(),"w");
        double v[512],I[512],p[10] = {33,50,0,0,0,0.4,0.15,5000,54.7,0};
        MoessCalc m;
        for(int i = 0; i < 512; i++)
            v[i] = -7*cos((i+0.5)/512.*M_PI);
        m.get_SC_spectrum(I,512,v,p);
        for(int i = 0; i < 512; i++)
            I[i] += 100000;
        m.add_noise(I,512);
        for(int i = 0; i < 512; i++)
            fprintf(f,"%f\t%f\n",v[i],I[i]);
        fclose(f);
    }

    // check for mbs file
    QString defaultpath = QApplication::applicationDirPath().append("/default.mbs");
    if(!QFile(defaultpath).exists())
        fitmodel().generate_default(QStringList(defaultfld));

    //load default
    load_from_mbs(defaultpath);
}

bool MainWindow::load_from_fld(QStringList filelist){
    fitmodel().generate_default(filelist);
    QString mbspath = QString(filelist[0]).left(filelist[0].length()-3).append("mbs");
    return load_from_mbs(mbspath);
}

bool MainWindow::load_from_mbs(QString filename){
    clear_panel();
    cfmfile = filename;
    cfm = new fitmodel(filename);
    connect(cfm,SIGNAL(ready_to_plot()),this,SLOT(plot_current_fit_modell()));
    this->setWindowTitle(QString("MoessFit: %1").arg(cfmfile));
    if(cfm->is_valid()){
        ui->verticalLayout->addWidget(cfm->get_pannel());
        plot_current_fit_modell();
        return 1;
    }
    else{
        return 0;
    }
}
void MainWindow::plot_current_fit_modell(){
    cfm->plot(&MoessSpectrum,&EnergySpectrum);
    EnergySpectrum.raise();
    MoessSpectrum.raise();
}
void MainWindow::closeEvent(QCloseEvent *){
    EnergySpectrum.close();
    MoessSpectrum.close();
}
void MainWindow::child_keyevent(QKeyEvent *event){
    this->keyPressEvent(event);
}
void MainWindow::open_dialog(){
    QStringList filenames = QFileDialog::getOpenFileNames(this,
                                                        "Open file",QString(),
                                                          "folded moessbauer spectrum (*.fld);; fit model (*.mbs);; raw data (*.ws5 *.dat)");
    if(!filenames.isEmpty()){
        if(QString(filenames[0]).right(4)==".mbs")
            if(!load_from_mbs(filenames[0])){
                QMessageBox msgBox;
                msgBox.setText(QString("%1 couldn't be opened by MoessFit.")
                               .arg(filenames[0]));
                msgBox.exec();
            }

        if(QString(filenames[0]).right(4)==".fld")
            if(!load_from_fld(filenames)){
                QMessageBox msgBox;
                msgBox.setText(QString("%1 couldn't be opened by MoessFit.")
                               .arg(filenames[0]));
                msgBox.exec();
            }

        if(QString(filenames[0]).right(4)==".dat" || QString(filenames[0]).right(4)==".ws5"){
            clear_panel();
            Fold* f = new Fold(filenames[0],
                              QApplication::applicationDirPath()
                              .append("/fold.ini"));
            ui->verticalLayout->addWidget(f);
        }
    }
}
void MainWindow::folder_refine(){
    QString root = QFileDialog::getExistingDirectory(this,"select data folder");

    if(!root.isEmpty()){
        QDir folder(root);
        folder.setNameFilters(QStringList("*.fld"));
        folder.setFilter(QDir::Files);
        folder.setSorting(QDir::Time);
        int cfld = folder.entryList().count()+1;
        double **xt = new double*[cfld];
        double **yt = new double*[cfld];
        for(int i = 0; i < cfld; i++) xt[i] = yt[i] = NULL;
        int *ct = new int[cfld];        // channel count
        double* mean = new double[cfld];
        double* sigma = new double[cfld];
        int ci = 0;                     // valid spectra count
        /*get all data*/
        for(int i = 0; i < cfld-1; i++)
            if(fitmodel().from_fld(folder.path().append("/")
                                                .append(folder.entryList().at(i)).toLocal8Bit().data(),
                                   &(xt[ci]),&(yt[ci]),&(ct[ci])))
                ci++;
        /*check data to konformity*/
        int samect = 1;
        QString ErrorMessage;
        for(int i = 0; i < ci; i++)
            if(ct[i] != ct[0]){
                ErrorMessage.append(QString("Channel count of %1 (%2) differs from %3 (%4)\n")
                        .arg(folder.entryList().at(i)).arg(ct[i])
                        .arg(folder.entryList().at(0)).arg(ct[0]));
                samect = 0;
            }
        if(!samect)
            QMessageBox(QMessageBox::NoIcon,"Error",ErrorMessage).exec();
        else{
            //keep sum spectra
            clone(&(xt[ci]),xt[0],ct[0]);
            clone(&(yt[ci]),yt[0],ct[0]);
            ct[ci] = ct[0];
            //subtract
            for(int i = 0; i < ci-1; i++)
                for(int k = 0; k < ct[0]; k++)
                    yt[i][k] -= yt[i+1][k];
            //mean and sigma
            for(int i = 0; i < ci; i++){
                mean[i] = 0;
                for(int k = 0; k < ct[0]; k++)
                    mean[i] += yt[i][k];
                mean[i] = mean[i] / ct[0];
                sigma[i] = 0;
                for(int k = 0; k < ct[0]; k++)
                    sigma[i] += qMax(0.,(yt[i][k] - mean[i])*(yt[i][k] - mean[i])
                                        -yt[i][k]);
                sigma[i] = sigma[i] / mean[i];
            }
            //sort by sigma
            double** sindex = new double*[ci];
            for(int i = 0; i < ci; i++){
                sindex[i] = new double[2];
                sindex[i][0] = sigma[i];
                sindex[i][1] = 1.*i;
            }
            sort(sindex,0,ci-1);
            // data output
            int I0 = 0;
            init_array(yt[ci],ct[0],0.0);
            for(int i = ci-1; i >= 0; i--){
                int cii = int(sindex[i][1]);
                I0 += mean[cii];
                QString filename = QString("%1/Refined%2.fld")
                                   .arg(root).arg(I0);
                FILE *f = fopen(filename.toLocal8Bit().data(),"w");
                for(int k = 0; k < ct[0]; k++){
                    yt[ci][k] += yt[cii][k];
                    fprintf(f,"%f\t%f\n",xt[ci][k],yt[ci][k]);
                }
                fclose(f);
            }
            // free data
            for(int i = 0; i < ci; i++)
                delete sindex[i];
            delete sindex;
        }

        // free all data
        for(int i = 0; i < ci; i++){
            if(xt[i] != NULL) delete xt[i];
            if(yt[i] != NULL) delete yt[i];
        }
        delete mean;
        delete sigma;
        delete xt;
        delete yt;
        delete ct;
    }
}
void MainWindow::folder_to_tiff(){
    QString root = QFileDialog::getExistingDirectory(this,"select data folder");

    if(!root.isEmpty()){
        QDir folder(root);
        folder.setNameFilters(QStringList("*.fld"));
        folder.setFilter(QDir::Files);
        folder.setSorting(QDir::Time);
        int cfld = folder.entryList().count()+1;
        double **xt = new double*[cfld];
        double **yt = new double*[cfld];
        for(int i = 0; i < cfld; i++) xt[i] = yt[i] = NULL;
        int *ct = new int[cfld];
        QDateTime* date = new QDateTime[cfld];
        int ci = 0;
        /*get all data*/
        for(int i = 0; i < cfld-1; i++)
            if(fitmodel().from_fld(folder.path().append("/")
                                                .append(folder.entryList().at(i)).toLocal8Bit().data(),
                                   &(xt[ci]),&(yt[ci]),&(ct[ci]))){
                date[ci] = QFileInfo(folder,folder.entryList().at(i)).lastModified();
                ci++;
            }
        /*check data to konformity*/
        int samect = 1;
        QString ErrorMessage;
        for(int i = 0; i < ci; i++)
            if(ct[i] != ct[0]){
                ErrorMessage.append(QString("Channel count of %1 (%2) differs from %3 (%4)\n")
                        .arg(folder.entryList().at(i)).arg(ct[i])
                        .arg(folder.entryList().at(0)).arg(ct[0]));
                samect = 0;
            }
        if(!samect)
            QMessageBox(QMessageBox::NoIcon,"Error",ErrorMessage).exec();
        else{
            /*keep sum spectra*/
            clone(&(xt[ci]),xt[0],ct[0]);
            clone(&(yt[ci]),yt[0],ct[0]);
            ct[ci] = ct[0];
            date[ci] = date[ci-1];
            /*subtract*/
            for(int i = 0; i < ci-1; i++)
                for(int k = 0; k < ct[0]; k++)
                    yt[i][k] -= yt[i+1][k];
            /*normalize to upper 50 %*/
            double Norm0 = 1;
            for(int i = 0; i < ci+1; i++){
                QList<double> sortedlist;
                for(int k = 0; k < ct[0]; k++) sortedlist.append(yt[i][k]);
                qSort(sortedlist);
                double norm = 0;
                for(int k = ct[0]-1; k > 0.5 * ct[0]; k--)
                    norm += sortedlist.at(k);
                norm = std::max(1.,norm / std::max(1.,(ct[0]-1)-0.5*ct[0]));
                for(int k = 0; k < ct[0]; k++)
                    yt[i][k] = yt[i][k] / norm;
                if(i==ci)
                    Norm0 = norm;
            }
            /*get bounds*/
            double  vmin = min_array(xt[ci],ct[ci]),
                    vmax = max_array(xt[ci],ct[ci]),
                    Imin = min_array(yt[ci],ct[ci]),
                    Imax = max_array(yt[ci],ct[ci]);
            Imin -= 3*sqrt(ci/Norm0);
            Imax += 3*sqrt(ci/Norm0);
            // get bounds
            /*double minSum = sum(yt[0],ct[0])/qMax(1,ci);
                   minSum = minSum-3*sqrt(minSum);
            for(int i = 0; i < ci+1; i++){
                // first check if it is a reasonable dataset
                if(sum(yt[i],ct[i])>minSum)
                    for(int k = 0; k < ct[0]; k++){
                        if(xt[i][k] > vmax) vmax = xt[i][k];
                        if(xt[i][k] < vmin) vmin = xt[i][k];
                        if(yt[i][k] > Imax) Imax = yt[i][k];
                        if(yt[i][k] < Imin) Imin = yt[i][k];
                    }
            }*/
            /*draw pictures*/
            plot2D plot;
            int width = 600, height = 300;
            plot.resize(width,height);
            double *yaverage = new double[ct[0]];
            double *yaverage2 = new double[ct[0]];
            double* ypoint[2];
            double* xpoint[2];
            int ccpoint[2];
            double* yline[2];
            double* xline[2];
            int ccline[2];
            QStringList labels;
            xpoint[1] =   xt[ci];      ypoint[1] = yt[ci];
            xline[1]  =   xt[ci];  yline[1]  = yaverage2; yline[0] = yaverage;
            labels.append("");
            labels.append(QString("from %1\nto %2").arg(date[ci].toString()).arg(date[0].toString()));
            ccpoint[0] = ccpoint[1] = ct[0];
            ccline[0] = ccline[1] = ct[0]-10;
            /*average sum spectra*/
            for(int i = 5; i < ct[0]-5; i++){
                yaverage2[i] = 0;
                for(int k = - 5; k <= 5; k++)
                    yaverage2[i] += yt[ci][i+k];
                yaverage2[i] = yaverage2[i] / 11.;
            }

            /*create every plot*/
            unsigned char ***bits = new unsigned char**[ci];
            for(int i = 0; i < ci; i++){
                labels.replace(0,QString("%1").arg(date[i].toString()));
                ypoint[0] = yt[i];
                xpoint[0] = xt[i];
                xline [0] = xt[i];
                for(int j = 5; j < ct[0]-5; j++){
                    yaverage[j] = 0;
                    for(int k = - 5; k <= 5; k++)
                        yaverage[j] += yt[i][j+k];
                    yaverage[j] = yaverage[j] / 11.;
                }
                plot.set_pointdata(2,ccpoint,xpoint,ypoint);
                plot.set_linedata(2,ccline,xline,yline);
                plot.set_legend(&labels);
                plot.set_range(vmin,vmax,Imin,Imax);
                bits[i] = plot.get_bits();
            }
            /*create tiff*/
            DataTif(bits,height,width,ci,root.append("/Evolution.tif").toLocal8Bit().data());
            /*free data*/
            for(int i = 0; i < ci; i++){
                for(int h = 0; h < height; h++)
                    delete bits[i][h];
                delete bits[i];
            }
            delete bits;
            delete yaverage;
            delete yaverage2;
        }

        /*free all data*/
        for(int i = 0; i < ci; i++){
            if(xt[i] != NULL) delete xt[i];
            if(yt[i] != NULL) delete yt[i];
        }
        delete xt;
        delete yt;
        delete ct;
    }
}
void MainWindow::clear_panel(){
    while(!ui->verticalLayout->isEmpty()) {
        delete ui->verticalLayout->itemAt(0)->widget();
    }
    if(cfm != NULL){
        cfm->~fitmodel();
        cfm = NULL;
    }
}
void MainWindow::add_noise(){
    cfm->add_noise();
}
void MainWindow::run_test_suite(){
    char intention[14][100]={
        "MLR model",
        "Debye models",
        "AFMBex model",
        "extended DISTR function",
        "extended 2D-MEM function",
        "DynDyn model with beta",
        "polarized source in field",
        "large run number",
        "Gaussian functions",
        "FeAs function",
        "2D MEM with large parameter count",
        "polarized source in field",
        "extended MEM",
        "MEM"
    };
    char mbs[14][100] = {
        "Testsuite\\FeAl2O3\\VglSerie.mbs",
        "Testsuite\\LaFeP0.6As0.4O-FeReference\\AnalysisF.mbs",
        "Testsuite\\CuFeAs-Bex\\afmBexAnalysis2fracTIF.mbs",
        "Testsuite\\LiCuFe2(V04)3\\SchiefeDistr.mbs",
        "Testsuite\\Fe3PO4O3\\MEM_zeta_alpha_fixedVzz_smallN.mbs",
        "Testsuite\\Li2Li-xFexNx0.015\\FluctuationPlusMinusB.mbs",
        "Testsuite\\EisenfolieLongitudinal7T\\Analysis.mbs",
        "Testsuite\\FeS-LiOH\\ThickAbsorber.mbs",
        "Testsuite\\Na0.7La0.3Fe2As2\\Auswertung2015_TI.mbs",
        "Testsuite\\CuFeAs-2nd\\Auswertung.mbs",
        "Testsuite\\FeSe\\300,1K - MEM-CS-Vzz.mbs",
        "Testsuite\\EisenfolieTransversal7T\\Analysis.mbs",
        "Testsuite\\CuFeSb-Bex\\AuswertungCorrelatedFullBexFM.mbs",
        "Testsuite\\EuFe2(As0.82P0.18)2-2nd\\fitMEM.mbs"
    };
    double chi2[14]={
        2852.733507,
        9825.508641,
        9960.121202,
        10020.050739,
        1400.759567,
        8871.043945,
        6126.004789,
        37413.367621,
        12425.928900,
        10738.371956,
        529.934108,
        4987.173571,
        3994.758215,
        9302.437277};


    FILE* f = fopen("testsuite.txt","w");
    for(int i = 0; i < 14; i++){
        double nchi2 = fitmodel(QString(mbs[i])).get_total_chi2();
        fprintf(f,"dchi2: %f; %s, %s\n",nchi2-chi2[i],intention[i],mbs[i]);
    }
    fclose(f);
}
void MainWindow::linearize_data(){
    cfm->save_linear_v_spectra();
}

void MainWindow::merge_runlog(QString path){
    QDir d(path);
}
