﻿#include "memdialog.h"
#include <QGridLayout>
#include <QLineEdit>
#include <QLabel>
#include <QPushButton>


MEMDialog::MEMDialog(QWidget *parent, fitpara* p,
                     MEMParameters *MP) : QDialog(parent){
    clearbins = 1;
    this->MP = MP;

    QString captions[11][3]={
        {"CS    min","CS max","CS steps"},
        {"B     min","B     max","B     steps"},
        {"Vzz   min","Vzz max","Vzz steps"},
        {"eta   min","eta   max","eta   steps"},
        {"theta min","theta max","theta steps"},
        {"phi   min","phi   max","phi   steps"},
        {"omega min","omega max","omega steps"},
        {"I0    min","I0    max","I0    steps"},
        {"A     min","A     max","A     steps"},
        {"beta  min","beta  max","beta  steps"},
        {"gamma min","gamma max","gamma steps"}};

    min =(QLineEdit**)malloc(11*sizeof(QLineEdit*));
    max =(QLineEdit**)malloc(11*sizeof(QLineEdit*));
    steps =(QLineEdit**)malloc(11*sizeof(QLineEdit*));
    for(int i = 0; i < 11; i++){
        min[i] = new QLineEdit();
        max[i] = new QLineEdit();
        steps[i] = new QLineEdit();
        steps[i]->setText("1");
    }
    min[ 0]->setText(QString("%1").arg(p->p[ 0]));
    min[ 1]->setText(QString("%1").arg(p->p[ 1]));
    min[ 2]->setText(QString("%1").arg(p->p[ 2]));
    min[ 3]->setText(QString("%1").arg(p->p[ 3]));
    min[ 4]->setText(QString("%1").arg(p->p[ 4]));
    min[ 5]->setText(QString("%1").arg(p->p[ 5]));
    min[ 6]->setText(QString("%1").arg(p->p[ 6]));
    min[ 7]->setText(QString("%1").arg(p->p[ 7]));
    min[ 8]->setText(QString("%1").arg(p->p[ 8]));
    min[ 9]->setText(QString("%1").arg(p->p[ 9]));
    min[10]->setText(QString("%1").arg(p->p[10]));
    max[ 0]->setText(min[ 0]->text());
    max[ 1]->setText(min[ 1]->text());
    max[ 2]->setText(min[ 2]->text());
    max[ 3]->setText(min[ 3]->text());
    max[ 4]->setText(min[ 4]->text());
    max[ 5]->setText(min[ 5]->text());
    max[ 6]->setText(min[ 6]->text());
    max[ 7]->setText(min[ 7]->text());
    max[ 8]->setText(min[ 8]->text());
    max[ 9]->setText(min[ 9]->text());
    max[10]->setText(min[10]->text());

    setWindowTitle("MEM Optionen");
    QGridLayout* L = new QGridLayout;
    for(int i = 0; i < 11; i++){
        QLabel *minlabel = new QLabel(captions[i][0]);
        QLabel *maxlabel = new QLabel(captions[i][1]);
        QLabel *steplabel = new QLabel(captions[i][2]);
        L->addWidget(minlabel,i,0);
        L->addWidget(min[i],i,1);
        L->addWidget(maxlabel,i,3);
        L->addWidget(max[i],i,4);
        L->addWidget(steplabel,i,6);
        L->addWidget(steps[i],i,7);
    }
    integrateCheckBox = new QCheckBox(QString("integrierte Intensität, unabhängig von beta und gamma"));
    if(p->integrate) integrateCheckBox->setCheckState(Qt::Checked);
    else             integrateCheckBox->setCheckState(Qt::Unchecked);
    L->addWidget(integrateCheckBox,11,0,1,5);

    iterations = new QLineEdit();
    QLabel *iterationslabel = new QLabel(QString("Iterationen"));
    L->addWidget(iterationslabel,12,0);
    iterations->setText(QString("200"));
    L->addWidget(iterations,12,1);
    stepsize = new QLineEdit();
    QLabel *stepsizelabel = new QLabel(QString("Schrittweite"));
    L->addWidget(stepsizelabel,12,2);
    stepsize->setText(QString("0.01"));
    L->addWidget(stepsize,12,3);
    maxdiff = new QLineEdit();
    QLabel *maxdifflabel = new QLabel(QString("MEM-Tolleranz"));
    L->addWidget(maxdifflabel,12,4);
    maxdiff->setText(QString("0.05"));
    L->addWidget(maxdiff,12,5);
    maxlambda = new QLineEdit();
    QLabel *maxlamdalabel = new QLabel(QString("max. Chi2-Wichtung"));
    L->addWidget(maxlamdalabel,12,6);
    maxlambda->setText(QString("1"));
    L->addWidget(maxlambda,12,7);

    QPushButton* btn1 = new QPushButton("Verteilung berechnen");
    connect(btn1, SIGNAL(clicked()), this, SLOT(calc()));
    L->addWidget(btn1,13,0,1,2);

    QPushButton* btn2 = new QPushButton("Abbrechen");
    connect(btn2, SIGNAL(clicked()), this, SLOT(cancel()));
    L->addWidget(btn2,14,0,1,2);

    setLayout(L);
}

MEMDialog::MEMDialog(QWidget *parent,int keep_Pdata,
                     MEMParameters *MP) : QDialog(parent){
    clearbins = !keep_Pdata;
    this->MP = MP;
    QString captions[11][3]={
        {"CS    min","CS max","CS steps"},
        {"B     min","B     max","B     steps"},
        {"Vzz   min","Vzz max","Vzz steps"},
        {"eta   min","eta   max","eta   steps"},
        {"theta min","theta max","theta steps"},
        {"phi   min","phi   max","phi   steps"},
        {"omega min","omega max","omega steps"},
        {"I0    min","I0    max","I0    steps"},
        {"A     min","A     max","A     steps"},
        {"beta  min","beta  max","beta  steps"},
        {"gamma min","gamma max","gamma steps"}};

    min =(QLineEdit**)malloc(11*sizeof(QLineEdit*));
    max =(QLineEdit**)malloc(11*sizeof(QLineEdit*));
    steps =(QLineEdit**)malloc(11*sizeof(QLineEdit*));
    for(int i = 0; i < 11; i++){
        min[i] = new QLineEdit();
        max[i] = new QLineEdit();
        steps[i] = new QLineEdit();
    }

    for(int i = 0; i < 11; i++){
        min[i]->setText(QString("%1").arg(MP->p[i].min));
        max[i]->setText(QString("%1").arg(MP->p[i].max));
        steps[i]->setText(QString("%1").arg(MP->p[i].steps));
    }

    setWindowTitle("MEM Optionen");
    QGridLayout* L = new QGridLayout;
    for(int i = 0; i < 11; i++){
        QLabel *minlabel = new QLabel(captions[i][0]);
        QLabel *maxlabel = new QLabel(captions[i][1]);
        QLabel *steplabel = new QLabel(captions[i][2]);
        L->addWidget(minlabel,i,0);
        L->addWidget(min[i],i,1);
        L->addWidget(maxlabel,i,3);
        L->addWidget(max[i],i,4);
        L->addWidget(steplabel,i,6);
        L->addWidget(steps[i],i,7);
    }
    integrateCheckBox = new QCheckBox(QString("integrierte Intensität, unabhängig von beta und gamma"));
    if(MP->integrate) integrateCheckBox->setCheckState(Qt::Checked);
    else              integrateCheckBox->setCheckState(Qt::Unchecked);
    L->addWidget(integrateCheckBox,11,0,1,5);

    iterations = new QLineEdit();
    QLabel *iterationslabel = new QLabel(QString("Iterationen"));
    L->addWidget(iterationslabel,12,0);
    iterations->setText(QString("%1").arg(MP->iterations));
    L->addWidget(iterations,12,1);
    stepsize = new QLineEdit();
    QLabel *stepsizelabel = new QLabel(QString("Schrittweite"));
    L->addWidget(stepsizelabel,12,2);
    stepsize->setText(QString("%1").arg(MP->stepsize));
    L->addWidget(stepsize,12,3);
    maxdiff = new QLineEdit();
    QLabel *maxdifflabel = new QLabel(QString("MEM-Tolleranz"));
    L->addWidget(maxdifflabel,12,4);
    maxdiff->setText(QString("%1").arg(MP->maxdiff));
    L->addWidget(maxdiff,12,5); 
    maxlambda = new QLineEdit();
    QLabel *maxlamdalabel = new QLabel(QString("max. Chi2-Wichtung"));
    L->addWidget(maxlamdalabel,12,6);
    maxlambda->setText(QString("%1").arg(MP->maxlambda));
    L->addWidget(maxlambda,12,7);

    QPushButton* btn1 = new QPushButton("Verteilung berechnen");
    connect(btn1, SIGNAL(clicked()), this, SLOT(calc()));
    L->addWidget(btn1,13,0,1,2);

    QPushButton* btn2 = new QPushButton("Abbrechen");
    connect(btn2, SIGNAL(clicked()), this, SLOT(cancel()));
    L->addWidget(btn2,14,0,1,2);

    setLayout(L);
}
MEMDialog::MEMDialog(QWidget *parent, int *index){
    QGridLayout* L = new QGridLayout;
    CB = new QComboBox;
    CB->addItem(QString("CS"));
    CB->addItem(QString("B"));
    CB->addItem(QString("Vzz"));
    CB->addItem(QString("eta"));
    CB->addItem(QString("omega"));
    CB->addItem(QString("I0"));
    CB->addItem(QString("A"));
    CB->addItem(QString("phi"));
    CB->addItem(QString("theta"));
    CB->addItem(QString("beta"));
    CB->addItem(QString("gamma"));
    L->addWidget(CB,1,0);
    QPushButton* btn1 = new QPushButton("OK");
    connect(btn1, SIGNAL(clicked()), this, SLOT(accept_Paramindex()));
    L->addWidget(btn1,2,0);
    setLayout(L);
    this->index = index;
}
void MEMDialog::calc(){
    int step = 1;
    for(int i = 0; i < 11; i++){
        MP->p[i].steps = steps[i]->text().toInt();
        MP->p[i].max = max[i]->text().toDouble();
        MP->p[i].min = min[i]->text().toDouble();
        if(MP->p[i].min == MP->p[i].max)
            MP->p[i].steps = 1;
        step = step * MP->p[i].steps;
    }


    if(clearbins || MP->steps != step){
        /*Stutzstellen neu anlegen und gleichverteilen*/
        if(MP->Pdata != NULL){
            free(MP->Pdata);
            free(MP->Perror);
            MP->Pdata = NULL;
        }
        MP->Pdata = (double*)malloc(step*sizeof(double));
        MP->Perror = (double*)malloc(step*sizeof(double));
        for(int b = 0; b < step; b++){
            MP->Pdata[b] = 1./step;
            MP->Perror[b] = 0;
        }
    }
    MP->steps = step;



    if(integrateCheckBox->isChecked())
        MP->integrate = 1;
    else
        MP->integrate = 0;

    MP->stepsize = stepsize->text().toDouble();
    MP->iterations = iterations->text().toDouble();
    MP->maxdiff = maxdiff->text().toDouble();
    MP->maxlambda = maxlambda->text().toDouble();

    MP->stepstoresult = 0;
    MP->chi2 = 0;
    MP->lambda = 0;
    MP->angle = 0;
    MP->diff = 0;

    if(step > 1)
        accept();
    else{
        QMessageBox msgBox;
        msgBox.setText(QString("Keine zu variierender Parameter gekennzeichnet"));
        msgBox.exec();
    }

}
void MEMDialog::cancel(){
    reject();
}
void MEMDialog::accept_Paramindex(){
    *index = CB->currentIndex();
    accept();
}
