#include "runlog_merge.h"


runlog_entry::runlog_entry(QDateTime D, double He, double LN){
    this->D = D;
    this->He = He;
    this->LN = LN;
}
runlog_entry::~runlog_entry(){}

bool runlog_entry::operator==(runlog_entry o){
    if(this->D == o.D)
        return true;
    else
        return false;
}
bool runlog_entry::operator<(const runlog_entry o2)const{
    if(this->D < o2.D)
        return true;
    else
        return false;
}

runlog_merge::runlog_merge(QString path){
    search_runlog(path);
}

void runlog_merge::search_runlog(QString path){
    QFileInfo f(path);
    if(f.isFile()){
        if(f.fileName() == "RunLog.txt")
            add(path);
    }
    else
        if(f.isDir()){
            QDir d(path);
            d.setFilter(QDir::NoDotAndDotDot|QDir::Files|QDir::Dirs);
            QStringList el = d.entryList();
            for(int i = 0; i < d.entryList().length(); i++)
                search_runlog(d.absoluteFilePath(d.entryList().at(i)));
        }
}

void runlog_merge::add(QString path){
    FILE* f = fopen(path.toLocal8Bit().data(),"r");
    if(f != NULL){
        double Heold = -100;
        char buf[1000];
        while(!feof(f)){
            fgets(buf,1000,f);
            QStringList sl = QString(buf).split("\t");
            if(sl.length() >= 11){
                double He = sl.at(5).toDouble();
                double LN = sl.at(6).toDouble();
                QDateTime D(QDate::fromString(sl.at(0),"dd.MM.yyyy"),
                            QTime::fromString(sl.at(1),"hh:mm:ss"));
                if(He != Heold){
                    Heold = He;
                    l.append(runlog_entry(D,He,LN));
                }
            }
        }
    }
    fclose(f);
}

void runlog_merge::save(QString path){
    qSort(l.begin(),l.end());
    FILE* f = fopen(path.toLocal8Bit().data(),"w");
    //QString check = l.at(0).D.toString("dd.MM.yyyy hh:mm:ss");
    //check = l.at(0).D.currentDateTime().toString("dd.MM.yyyy hh:mm:ss");
    if(f != NULL){
        for(int i = 0; i < l.length(); i++)
            fprintf(f,"%s\t%s\t%.1f\t%.1f\n",l.at(i).D.toString("dd/MM/yyyy").toLocal8Bit().data(),
                                         l.at(i).D.toString("hh:mm:ss").toLocal8Bit().data(),
                                     l.at(i).He,l.at(i).LN);
    }
    fclose(f);
}
